% % 
% % CPremebida: 2014
% % updated on: 12/June
% % 
% % Reference:
% % @INPROCEEDINGS{FusionIROS14,
% % author={Premebida, C. and Carreira, J. and Batista, J. and Nunes, U.},
% % booktitle={IROS},
% % title={Pedestrian detection combining {RGB} and dense {LIDAR} data},
% % year={2014},
% % month={Sep},
% % pages={0-1},
% % organization={IEEE}, }
% %------------------------------------------------------------------------
function Ima_Range = Fun_dense_range_map(calib,calib_dir,base_dir,...
    frame,ImaRGB)

T = Fun_open_calib(calib.name,calib_dir);

fd = fopen(sprintf('%s/%06d.bin',base_dir,frame),'rb');
if fd < 1
    fprintf('No LIDAR files !!!\n');
    keyboard
else
velo = fread(fd,[4 inf],'single')';
fclose(fd);
end

% remove all points behind image plane (approximation)
idx = velo(:,1)<5;
velo(idx,:) = [];

% project to image plane (exclude luminance)
px = (T.P2 * T.R0_rect * T.Tr_velo_to_cam * velo')';
px(:,1) = px(:,1)./px(:,3);
px(:,2) = px(:,2)./px(:,3);
% % -----------------------------------------------------------------------
ix = px(:,1)<1;                 px(ix,:)=[];
ix = px(:,1)>size(ImaRGB,2);    px(ix,:)=[];
ix = px(:,2)>size(ImaRGB,1);    px(ix,:)=[];
% % Ordering
Pts = zeros(size(px,1),4);
Pts = sortrows(px,2);
% % ======================= Interpolation / Upsampling :::
c_px = floor(min(px(:,2)));
i_size = size(ImaRGB(c_px:end,:,1));
Ima3D = zeros( size(ImaRGB(:,:,1)) );

% Simply type: mex fun_dense3D.cpp
Ima3D(c_px:end,:) = fun_dense3D(Pts,[c_px i_size]); % MEX-file
% % -----------------------------------------------------------------------
% Normalization 8 bits
Ima_Range = uint8( 255*Ima3D/max(max(Ima3D)) ); % :)

end %END main Function
